Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions

# LightReMutexDirect Class Reference

This class implements a standard lightReMutex by making direct calls to the underlying implementation layer. More...

Inheritance diagram for LightReMutexDirect:

List of all members.

## Public Member Functions
| acquire ()
| Grabs the lightReMutex if it is available.
| acquire (Thread current_thread)
| This variant on acquire() accepts the current thread as a parameter, if it is already known, as an optimization.
| clearName ()
| The mutex name is only defined when compiling in DEBUG_THREADS mode.
bool | debugIsLocked ()
| Returns true if the current thread has locked the LightReMutex, false otherwise.
| elevateLock ()
| This method increments the lock count, assuming the calling thread already holds the lock.
string | getName ()
| The mutex name is only defined when compiling in DEBUG_THREADS mode.
bool | hasName ()
| The mutex name is only defined when compiling in DEBUG_THREADS mode.
| output (ostream out)
| This method is declared virtual in MutexDebug, but non-virtual in LightReMutexDirect.
| release ()
| Releases the lightReMutex.
| setName (string name)
| The mutex name is only defined when compiling in DEBUG_THREADS mode.

## Detailed Description

This class implements a standard lightReMutex by making direct calls to the underlying implementation layer.

It doesn't perform any debugging operations.

## Member Function Documentation

acquire | ( |  | ) |

Grabs the lightReMutex if it is available.

If it is not available, blocks until it becomes available, then grabs it. In either case, the function does not return until the lightReMutex is held; you should then call unlock().

This method is considered const so that you can lock and unlock const lightReMutexes, mainly to allow thread-safe access to otherwise const data.

Also see LightReMutexHolder.

acquire | ( | Thread | current_thread | ) |

This variant on acquire() accepts the current thread as a parameter, if it is already known, as an optimization.

clearName | ( |  | ) |

The mutex name is only defined when compiling in DEBUG_THREADS mode.

bool debugIsLocked | ( |  | ) |

Returns true if the current thread has locked the LightReMutex, false otherwise.

This method is only intended for use in debugging, hence the method name; in the LightReMutexDirect case, it always returns true, since there's not a reliable way to determine this otherwise.

elevateLock | ( |  | ) |

This method increments the lock count, assuming the calling thread already holds the lock.

After this call, release() will need to be called one additional time to release the lock.

This method really performs the same function as acquire(), but it offers a potential (slight) performance benefit when the calling thread knows that it already holds the lock. It is an error to call this when the calling thread does not hold the lock.

string getName | ( |  | ) |

The mutex name is only defined when compiling in DEBUG_THREADS mode.

bool hasName | ( |  | ) |

The mutex name is only defined when compiling in DEBUG_THREADS mode.

output | ( | ostream | out | ) |

This method is declared virtual in MutexDebug, but non-virtual in LightReMutexDirect.

release | ( |  | ) |

Releases the lightReMutex.

It is an error to call this if the lightReMutex was not already locked.

This method is considered const so that you can lock and unlock const lightReMutexes, mainly to allow thread-safe access to otherwise const data.

setName | ( | string | name | ) |

The mutex name is only defined when compiling in DEBUG_THREADS mode.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties